#define PRAGMA_PATH "Models"

#include <acknex.h>
#include <default.c>

#include <POVHelper.c>

void boxGround()
{
	my.skill1 = 0;
	vec_set(my.scale_x, vector(1, 2, 1));
	c_setminmax(my);
}

void sphereTarget()
{
	my.skill1 = 1;
}

void sphereThrown()
{
	my.skill1 = 1;
	var speeddown = 0;
	while(!key_e){wait(1);}
	while(!key_r)
	{
		my.x -= 4;
		speeddown += 0.04*9.81;
		my.z -= speeddown*0.4;
		wait(1);
	}
}

void loadLevel()
{
	level_load("");
	ent_create("box.mdl", vector(0, 0, -0.5), boxGround);
	ent_create("sphere.mdl", vector(0, -1, 1), sphereTarget);
	ent_create("sphere.mdl", vector(0, 1, 1), sphereTarget);
	ent_create("sphere.mdl", vector(0, 0, 2.73205081), sphereTarget);
	ent_create("sphere.mdl", vector(40, 0, 5), sphereThrown);
}

void resetLevel()
{
	VECTOR cam_pos;
	ANGLE cam_ang;
	vec_set(cam_pos, camera.x);
	vec_set(cam_ang, camera.pan);
	
	loadLevel();
	
	vec_set(camera.x, cam_pos);
	vec_set(camera.pan, cam_ang);
}

void record()
{
	recordFrames("Scene", 15, 25);
}

void main()
{
	fps_max = 25;
	
	loadLevel();
	
	on_e = record;
	on_r = resetLevel;
	on_space = render;
}