STRING* povInit =
"
#include \"colors.inc\"
#include \"textures.inc\"
#include \"shapes.inc\"

light_source { <10, 2, 0> rgb <1.0, 1.0, 1.0>}

";

STRING* currFile = "#1000";
STRING* outDir = "Output";

void writeFrame(STRING* name, var frame_)
{
	STRING* tempstr = str_create("#1000");
	STRING* tempstr2 = str_create("#1000");
	var fh;
	VECTOR lookat;
	vec_for_angle(lookat, camera.pan);
	vec_add(lookat, camera.x);
	
	str_cpy(tempstr, outDir);
	str_cat(tempstr, "\\");
	str_cat(tempstr, name);
	str_cat_num(tempstr, "%.0f", frame_);
	str_cat(tempstr, ".pov");
	fh = file_open_write(tempstr);
	
	file_str_write(fh, povInit);
	
	file_str_write(fh, "camera{location<");
	file_var_write(fh, camera.x);
	file_str_write(fh, ",");
	file_var_write(fh, camera.z);
	file_str_write(fh, ",");
	file_var_write(fh, camera.y);
	file_str_write(fh, ">look_at<");
	file_var_write(fh, lookat.x);
	file_str_write(fh, ",");
	file_var_write(fh, lookat.z);
	file_str_write(fh, ",");
	file_var_write(fh, lookat.y);
	file_str_write(fh, ">}\n");
	
	for(you = ent_next(NULL); you != NULL; you = ent_next(you))
	{
		switch(you.skill1)
		{
			case 0:
				file_str_write(fh, "box{<");
				file_var_write(fh, you.max_x+you.x);
				file_str_write(fh, ",");
				file_var_write(fh, you.max_z+you.z);
				file_str_write(fh, ",");
				file_var_write(fh, you.max_y+you.y);
				file_str_write(fh, ">,<");
				file_var_write(fh, you.min_x+you.x);
				file_str_write(fh, ",");
				file_var_write(fh, you.min_z+you.z);
				file_str_write(fh, ",");
				file_var_write(fh, you.min_y+you.y);
				file_str_write(fh, ">");
				file_str_write(fh, "pigment { rgb <0.0, 1.0, 1.0> }}\n");
			break;
			
			case 1:
				file_str_write(fh, "sphere{<");
				file_var_write(fh, you.x);
				file_str_write(fh, ",");
				file_var_write(fh, you.z);
				file_str_write(fh, ",");
				file_var_write(fh, you.y);
				file_str_write(fh, ">,");
				file_var_write(fh, you.max_x);
				file_str_write(fh, "pigment { rgb <0.0, 1.0, 1.0> }}\n");
			break;
		}
	}
	file_close(fh);
	
	str_cpy(tempstr2, outDir);
	str_cat(tempstr2, "\\");
	str_cat(tempstr2, name);
	str_cat(tempstr2, "r.bat");
	
	if(frame_ == 0)
	{
		fh = file_open_write(tempstr2);
	}else
	{
		fh = file_open_append(tempstr2);
	}
	
	str_cpy(tempstr, outDir);
	str_cat(tempstr, "\/");
	str_cat(tempstr, name);
	str_cat_num(tempstr, "%.0f", frame_);
	str_cat(tempstr, ".pov");
	
	str_cpy(tempstr2, "\"H:\\Programme\\POV Ray\\bin\\pvengine.exe\" /EXIT /RENDER ");
	str_cat(tempstr2, tempstr);
	str_cat(tempstr2, "\n");
	file_str_write(fh, tempstr2);
	file_close(fh);
}

void addBmapToAVI(STRING* filename, var num, var fps)
{
	STRING* tempstr = str_create("#1000");
	str_cpy(tempstr, outDir);
	str_cat(tempstr, "\\");
	str_cat(tempstr, filename);
	str_cat(tempstr, "r.bat");
	var fh = file_open_append(tempstr);
	str_cpy(tempstr, "EasyBMPtoAVI -filebase ");
	str_cat(tempstr, outDir);
	str_cat(tempstr, "\\");
	str_cat(tempstr, filename);
	str_cat(tempstr, " -start 0 -end ");
	str_cat_num(tempstr, "%.0f", num-1);
	str_cat(tempstr, " -framerate ");
	str_cat_num(tempstr, "%.0f", fps);
	str_cat(tempstr, " -output ");
	str_cat(tempstr, outDir);
	str_cat(tempstr, "\\");
	str_cat(tempstr, filename);
	str_cat(tempstr, ".avi\n");
	file_str_write(fh, tempstr);
	file_close(fh);
}

void render()
{
	STRING* tempstr = str_create("#1000");
	str_cpy(tempstr, outDir);
	str_cat(tempstr, "\\");
	str_cat(tempstr, currFile);
	str_cat(tempstr, "r.bat");
	exec(tempstr, NULL);
}

void recordFrames(STRING* filename, var num, var fps)
{
	str_cpy(currFile, filename);
	
	int i;
	for(i = 0; i < num; i++)
	{
		writeFrame(currFile, (var)i);
		wait(1);
	}
	
	addBmapToAVI(currFile, num, fps);
}